/*
 * Copyright (C) 2002 Uwe Ohse, uwe@ohse.de
 * This is free software, licensed under the terms of the GNU General 
 * Public License Version 2, of which a copy is stored at:
 *    http://www.ohse.de/uwe/licenses/GPL-2
 * Later versions may or may not apply, see 
 *    http://www.ohse.de/uwe/licenses/
 * for information after a newer version has been published.
 */
#include "buffer.h"
#include "stralloc.h"
#include "attributes.h"
extern buffer io_i;
extern buffer io_o;
extern unsigned long o_loglevel;
extern int o_force_select;

extern unsigned long o_timeout;
extern unsigned long o_login_sleep;
extern stralloc remoteip; /* list of IP addresses of the host */

int do_pasv(void);
int connect_auth (const char *host, const char *o_user, 
	const char *o_pass, const char *o_acct, int tries);
char *ccread(void);
char *ccread_oneline(void);
void cmdwrite2(const char *s1, const unsigned char *s2);
void cmdwrite1(const char *s);
void x2(const char *where);
void sx2(const char *what);
void log1(const char *s1);
void log2(const char *s1, const char *s2);
void log3(const char *s1, const char *s2, const char *s3);
void log4(const char *s1, const char *s2, const char *s3, const char *s4);
void logmem(const char *s1,unsigned int l);
void warn_broken_mlsx(void);

void eof_or_error(int ec, int e, const char *s1,const char *s2, const char *s3)
 attribute_noreturn;
void sockrecbuf(int, unsigned long);


